package de.ciluvien.mensen.ui.viewmodels

import androidx.compose.runtime.mutableStateOf
import androidx.lifecycle.ViewModel
import androidx.lifecycle.viewModelScope
import androidx.lifecycle.viewmodel.compose.viewModel
import de.ciluvien.mensen.AppModule
import de.ciluvien.mensen.data.local.Bookmark
import de.ciluvien.mensen.data.local.Meal
import kotlinx.coroutines.launch
import java.time.LocalDate

class MealDetailsViewModel(appModule: AppModule) : ViewModel() {
    private val dao = appModule.canteenDao
    private val mealInit = Meal()
    private var _mealState = mutableStateOf(mealInit)
    val meal = _mealState
    private var _bookmarkState = mutableStateOf(false)
    val bookmarkState = _bookmarkState

    suspend fun getMeal(mealId: Int, date: LocalDate) {
        _mealState.value = dao.getMeal(mealId, date)!!
    }

    fun setBookmarkState(boolean: Boolean, date: LocalDate) {
        viewModelScope.launch {
            if (boolean) {
                dao.insertBookmark(Bookmark(mealId = meal.value.id, date))
            } else {
                dao.deleteBookmark(Bookmark(mealId = meal.value.id, date))
            }
            getBookmarkState(date)
        }
    }

    suspend fun getBookmarkState(date: LocalDate) {
        _bookmarkState.value = dao.getBookmark(meal.value.id, date) != null
    }
}